MageManaBar_UpdateInterval = 0.1; -- How often the OnUpdate code will run (in seconds)
MageManaBar1sec_UpdateInterval = 0.5;

--local MMBmanapoolmultiplier, MMBtempmanapool, MMBmanaoverflow, MMBbloodelfracial, MMBcurrenttime, MMBprevtime, MMBmanaspent, MMBhplost, MMBTimeToOom, MMBTimeToDie, MMBArcanePowerCD

function MageManaBar_OnLoad(Frame) 
                                               
    if select(2, UnitClass("player")) ~= "MAGE" then MageManaBarBgFrame:Hide() return end
        
	Frame:RegisterForDrag("LeftButton")
	Frame:RegisterEvent("PLAYER_LOGIN")
	Frame:RegisterEvent("PLAYER_REGEN_DISABLED")
	Frame:RegisterEvent("PLAYER_REGEN_ENABLED")
 	Frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
 	Frame:RegisterEvent("UNIT_MAXPOWER")
    
    if (MMBheightvar == nil) then MMBheightvar = 100 end 
    if (MMBwidthvar == nil) then MMBwidthvar = 300 end 
    if (MMBscalevar == nil) then MMBscalevar = 1 end
    if (MMBlevelvar == nil) then MMBlevelvar = 10 end
    if (MMBlockvar == nil) then MMBlockvar = true end
    
    MMBevocwarningcolor = 0
    MMBgemwarningcolor = 0
    MMBarcanewarningcolor = 0
    MMBevocationCDAnim = 0
    MMBmanaGemCDAnim = 0
    MMBArcaneTorrentCDAnim = 0
    MMBmanaGemFlash = 0
    MMBevocationFlash = 0
    MMBArcaneTorrentFlash = 0
    MMBmanaGemresize = 0
    MMBevocationresize = 0
    MMBArcaneTorrentresize = 0
    MMBtimers = true
        
end

-------------------------------
-- helper function for option panel setup
function MMBOptions_OnLoad(panel)
	panel.name = "MageManaBar"
	InterfaceOptions_AddCategory(panel);
end

-------------------------------
-- lock function for option panel
function MMBlock()

	if MMBlockButton:GetChecked(true) then MMBlockvar = true 
                                 MageManaBarBgFrame:EnableMouse(false)
                                 MMBlockButton:SetChecked(true)
                                 if (MMBchat==true) then ChatFrame1:AddMessage("|cff00ffffCombustionHelper locked|r") end
	else MMBlockvar = false 
         MageManaBarBgFrame:EnableMouse(true)
         MMBlockButton:SetChecked(false)
         if (MMBchat==true) then ChatFrame1:AddMessage("|cff00ffffCombustionHelper unlocked|r") end
	end
end

-------------------------------
-- Scale function for option panel
function MMBScale (scale)

    MMBscalevar = scale
	MageManaBarBgFrame:SetScale(scale)
end

-------------------------------
-- level function for option panel
function MMBlevel (level)

	MageManaBarBgFrame:SetFrameLevel(level)
	MMBlevelvar = level
end

-------------------------------
-- width function for option panel
function MMBwidth (width)

	MageManaBarBgFrame:SetWidth(width)
	MMBwidthvar = width
    MMBFrameResize()
end

-------------------------------
-- height function for option panel
function MMBheight (height)

	MageManaBarBgFrame:SetHeight(height)
	MMBheightvar = height
    MMBFrameResize()
end

MMBprefixtable = {"evocation","manaGem","ArcaneTorrent","mageArmor"}
                    
-------------------------------
-- Reset savedvariables function
function MMBFrameResize()

    MageManaBarBgFrame:SetWidth(MMBwidthvar)
    MageManaBarBgFrame:SetHeight(MMBheightvar)
    MageManaBarOverflowFrame:SetWidth(MMBwidthvar-2)
    MageManaBarOverflowFrame:SetHeight(MMBheightvar-2)
    MageManaBarFrame:SetWidth(MMBwidthvar-2)
    MageManaBarFrame:SetHeight(MMBheightvar-2)
    
    for i = 1,#MMBprefixtable do
        
        _G["MMB"..MMBprefixtable[i]]:SetHeight(MMBheightvar-2)
        _G["MMB"..MMBprefixtable[i].."gradred"]:SetHeight(MMBheightvar-2)
        _G["MMB"..MMBprefixtable[i].."gradblack"]:SetHeight(MMBheightvar-2)
        _G["MMB"..MMBprefixtable[i].."gradFrame"]:SetHeight(MMBheightvar-2)
    end
    
    MMBManabarMaxPool()
    MMBScale(MMBscalevar)
    MMBlevel(MMBlevelvar)
    
end

-------------------------------
-- Reset savedvariables function
function MMBreset()

    MMBheightvar = 100 
    MMBwidthvar = 300 
    MMBlevelvar = 10
    MMBscalevar = 1
    MMBlockvar = true
    MMBFrameResize()
    MageManaBarBgFrame:ClearAllPoints() 
    MageManaBarBgFrame:SetPoint("CENTER",UIParent,"CENTER",0,0)
    
end
function MMBManabarUpdate()

	MageManaBarFrame:SetValue(UnitPower("player"))
	MageManaBarOverflowFrame:SetValue(UnitPower("player"))

end

function MMBManabarMaxPool()

    MMBmanapoolmultiplier = 1.05
    MMBtempmanapool = 0

	for i = 1,40 do
	
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", i)
		
		if (spellId == 79061) or (spellId == 79063) then
			MMBmanapoolmultiplier = 1.1
		elseif spellId then
			for z = 1,#MMBbufflist do
				if (spellId == (MMBbufflist[z])[2]) then
					MMBtempmanapool = MMBtempmanapool + (MMBbufflist[z])[3]
                    table.insert(MMBcurrentbuff,{expirationTime,name,duration,(MMBbufflist[z])[3]})
					break
				end
			end	
		else break
		end
	end
	
	if (#MMBcurrentbuff ~= 0) then
	
	    for i = #MMBcurrentbuff,1,-1 do
	        
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitAura("player", (MMBcurrentbuff[i])[2])
	        if (name == nil) then
	            table.remove(MMBcurrentbuff,i)
	        end
	    end
	end
    
    MMBtempmanapool = (MMBtempmanapool * MMBmanapoolmultiplier)
    MMBregmanapool = UnitPowerMax("player")-MMBtempmanapool
	MageManaBarFrame:SetMinMaxValues(0,MMBregmanapool)
	MageManaBarOverflowFrame:SetWidth(MageManaBarFrame:GetWidth() * (UnitPowerMax("player")/MMBregmanapool ))
	MageManaBarOverflowFrame:SetMinMaxValues(0,UnitPowerMax("player"))
    
--	if (UnitPowerMax("player") ~= MMBregmanapool) then
--		MageManaBarBgFrame:SetWidth(MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player"))+2)
--	else MageManaBarBgFrame:SetWidth(MMBwidthvar)
--	end

    MMBmanaGem:ClearAllPoints()
    MMBmanaGem:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*(12405/MMBregmanapool)),0)
    MMBevocation:ClearAllPoints()
    MMBevocation:SetPoint("BOTTOMRIGHT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*0.6),0)
    MMBArcaneTorrent:ClearAllPoints()
    MMBArcaneTorrent:SetPoint("BOTTOMLEFT",MageManaBarFrame,"BOTTOMRIGHT", 0-(MageManaBarFrame:GetWidth()*0.06),0)

end

MMBmanahistory = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
MMBhphistory = {0,0,0,0,0,0,0,0,0,0}

function MMBTimeTo()
	
	table.insert(MMBmanahistory, UnitPower("player"))
	table.insert(MMBhphistory, UnitHealth("target"))
	table.remove(MMBmanahistory, 1)
	table.remove(MMBhphistory, 1)
	
	MMBmanaspent = (MMBmanahistory[1] - MMBmanahistory[40])
	MMBhplost = (MMBhphistory[9] - MMBmanahistory[10])
	
	MMBTimeToOom = (UnitPower("player") / MMBmanaspent) * 10
	MMBTimeToDie = (UnitHealth("target") / MMBhplost)
	
	if (MMBmanaspent == 0) then
		MMBInfoFrame1Text:SetText("TTOOM :   --")
	elseif (MMBTimeToOom < 0) then
		MMBInfoFrame1Text:SetText("TTOOM : Regen")
	elseif (MMBTimeToOom <= 60) then
		MMBInfoFrame1Text:SetText("TTOOM :",MMBTimeToOom)
	elseif (MMBTimeToOom > 60) then
		MMBInfoFrame1Text:SetText(format("TTOOM : %d:%0.2d",MMBTimeToOom / 60, MMBTimeToOom % 60))
	end
	
	if (MMBTimeToDie == 0) then
		MMBInfoFrame2Text:SetText("TTDIE :   --")
	elseif (MMBhplost < 0) then
		MMBInfoFrame2Text:SetText("TTDIE : Healing")
	elseif (MMBTimeToDie <= 60) then
		MMBInfoFrame2Text:SetText("TTDIE :",MMBTimeToDie)
	elseif (MMBTimeToDie > 60) then
		MMBInfoFrame2Text:SetText(format("TTDIE : %d:%0.2d",MMBTimeToDie / 60, MMBTimeToDie % 60))
	end
    
end

function MMBmanaInfoUpdate()

    MMBInfoFrame4Text:SetText(format("Mastery : +%.1f%%", (17 + (1.5 * GetMastery())) * (UnitPower("player")/UnitPowerMax("player")))) 
	MMBInfoFrame5Text:SetText(format("Max mana : %.1fk/%.1fk",MMBregmanapool/1000,UnitPowerMax("player")/1000))
    MMBInfoFrame6Text:SetText(format("Curr mana : %.1fk/%.1f%%",UnitPower("player")/1000,(UnitPower("player")/MMBregmanapool)*100))

end

function MMBwarning()

	local start, duration, enable = GetSpellCooldown(12042)
	
	if select(7,UnitAura("player", select(1,GetSpellInfo(12042)))) then
		MMBArcanePowerTimer = select(7,UnitAura("player", select(1,GetSpellInfo(12042)))) - GetTime()
	else MMBArcanePowerTimer = 0
	end
	 
	MMBevocationCD = select(2,GetSpellCooldown(12051))-(GetTime()-select(1,GetSpellCooldown(12051)))
	MMBmanaGemCD = select(2,GetSpellCooldown(5405))-(GetTime()-select(1,GetSpellCooldown(5405)))
	
	if (MMBArcanePowerTimer > 0) and (MMBmanaGemCD < 0) and (UnitPower("player") < (MMBregmanapool - 12405)) then
		MMBwarningtext:SetText(format("|cffffffffBurn : %.1f Use gem now !|r", MMBArcanePowerTimer))
   		MageManaBarWarningBar:SetMinMaxValues(0,select(6,UnitAura("player", select(1,GetSpellInfo(12042)))))
  		MageManaBarWarningBar:SetValue(MMBArcanePowerTimer)
	elseif (MMBArcanePowerTimer > 0) then
		MMBwarningtext:SetText(format("|cffffffffBurn : %.1f|r", MMBArcanePowerTimer))
   		MageManaBarWarningBar:SetMinMaxValues(0,select(6,UnitAura("player", select(1,GetSpellInfo(12042)))))
  		MageManaBarWarningBar:SetValue(MMBArcanePowerTimer)
  	elseif (MMBArcanePowerTimer == 0) and (UnitPower("player") < (MMBregmanapool * 0.4)) and (MMBevocationCD < 0) then
		MMBwarningtext:SetText(format("|cffffffff40%% mana, Evocate now !!|r"))
  		MageManaBarWarningBar:SetValue(0)
	elseif (UnitPower("player") > (UnitPowerMax("player")-MMBtempmanapool)) then
    
    	for i = #MMBcurrentbuff,1,-1 do
    	
    		MMBmanaoverflow = (UnitPower("player")-(UnitPowerMax("player")-MMBtempmanapool))/1000
    		MMBbuffoverflowtimer = (MMBcurrentbuff[i])[1]-GetTime()
    		
    		if (MMBmanaoverflow > 0) then
		        MMBwarningtext:SetText(format("|cffff0000OVERFLOW : %.1fk / %.1fs|r", MMBmanaoverflow, MMBbuffoverflowtimer))
        		MageManaBarWarningBar:SetMinMaxValues(0,(MMBcurrentbuff[i])[3])
        		MageManaBarWarningBar:SetValue(MMBbuffoverflowtimer)
   		        MageManaBarWarningBar:SetStatusBarColor(1,0.5,0.8,0.5)
        		break
        	elseif ((MMBcurrentbuff[i])[4] <= MMBmanaoverflow) then
        		MMBmanaoverflow = MMBmanaoverflow - (MMBcurrentbuff[i])[4]
        	end
        end
        	
	elseif (start == 0) and (MMBevocationCD <= 15) and (MMBmanaGemCD < 0) then
		MMBwarningtext:SetText(format("|cffafafafBurn phase ready...|r"))
  		MageManaBarWarningBar:SetValue(0)
	else MMBwarningtext:SetText("")
   		 MageManaBarWarningBar:SetValue(0)
         MageManaBarBgFrame:SetWidth(MMBwidthvar)
    end
end

function MMBSpellTimer(prefix,spellId)

    local start, duration, enable = GetSpellCooldown(spellId)
        
    if (duration > 1.55) and (_G["MMB"..prefix.."CDAnim"] == 0) then
        _G["MMB"..prefix.."Cooldown"]:SetCooldown(start,duration)
        _G["MMB"..prefix.."CDAnim"] = 1
    elseif (duration == 0) and (_G["MMB"..prefix.."CDAnim"] == 1) then
        _G["MMB"..prefix.."gradCooldown"]:SetCooldown(0,0)
        _G["MMB"..prefix.."CDAnim"] = 0
    end
    
    if (MMBtimers == true) and (duration > 1.55) then
        
        MMBspellCD = tonumber(format("%.0f",duration-(GetTime()-start)))
        local filename, fontHeight, flags = _G["MMB"..prefix.."Timer"]:GetFont()
        
        if (MMBspellCD == 0) then 
            _G["MMB"..prefix.."Timer"]:SetText("")
        elseif (MMBspellCD < 10) then
            if (_G["MMB"..prefix.."Flash"] < 3) then
                _G["MMB"..prefix.."Timer"]:SetText(format("|cffff0000%.0f|r",MMBspellCD))
                _G["MMB"..prefix.."Flash"] = _G["MMB"..prefix.."Flash"] + 1
            elseif (_G["MMB"..prefix.."Flash"] < 6) then
                _G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%.0f|r",MMBspellCD))
                _G["MMB"..prefix.."Flash"] = _G["MMB"..prefix.."Flash"] + 1
            else  _G["MMB"..prefix.."Flash"] = 1
            end
            if (_G["MMB"..prefix.."resize"] == 2) then 
            _G["MMB"..prefix.."Timer"]:SetFont(filename, fontHeight*(_G["MMB"..prefix.."Icon"]:GetHeight()/_G["MMB"..prefix.."Timer"]:GetStringHeight())*0.90, flags)
            _G["MMB"..prefix.."resize"] = 0
            end
        elseif (MMBspellCD <= 60) then
            _G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%.0f|r",MMBspellCD))
            if (_G["MMB"..prefix.."resize"] == 1) then 
                _G["MMB"..prefix.."Timer"]:SetFont(filename,fontHeight*(_G["MMB"..prefix.."Icon"]:GetHeight()/_G["MMB"..prefix.."Timer"]:GetStringHeight())*0.70,flags)
                _G["MMB"..prefix.."resize"] = 2
            end
        elseif (MMBspellCD > 60) then
            _G["MMB"..prefix.."Timer"]:SetText(format("|cffffff00%d:%0.2d|r",MMBspellCD / 60, MMBspellCD % 60))
            if (_G["MMB"..prefix.."resize"] == 0) then 
                _G["MMB"..prefix.."Timer"]:SetFont(filename,fontHeight*(_G["MMB"..prefix.."Icon"]:GetHeight()/_G["MMB"..prefix.."Timer"]:GetStringHeight())*0.50,flags)
                _G["MMB"..prefix.."resize"] = 1
            end
        end
    end
    
    if (SpellId == 5405) and (GetItemCount(36799, false,true) == 0) then
        MMBmanaGemIcon:SetVertexColor(1,0,0,1)
        print("prut")
    elseif (SpellId == 5405) and (GetItemCount(36799, false,true) ~= 0) then
        MMBmanaGemIcon:SetVertexColor(1,1,1,1)
        print("prutprut")
    end
    
end

	
	
MMBcurrentbuff = {}
    
MMBbufflist = {
	
	{"Power Torrent", 74241, 7500},
	{"Volcanic Power", 79476, 18000},
	{"Volcanic Destruction", 89091, 24000},
	{"Lightweave", 75170, 8700},
	{"Lightweave", 55367, 4425},
	{"Synapse Springs", 82175, 7200}
}
-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_EVENT FUNCTION ----------------------------------------------------

function MageManaBar_OnEvent(self, event, ...)

    if (event == "PLAYER_LOGIN") then
    
        MMBFrameResize()

        if (MMBlockvar == true) then 
            MageManaBarBgFrame:EnableMouse(false)
        else MageManaBarBgFrame:EnableMouse(true)
        end
        
        MageManaBarFrame:SetStatusBarColor(0.2,0.5,0.8)
        MageManaBarOverflowFrame:SetStatusBarColor(1,0.3,0.3,0.5)
   		MageManaBarWarningBar:SetMinMaxValues(0,2)
        
 		CreateFrame("Cooldown","MMBevocationCooldown",MMBevocationFrame)
		MMBevocationCooldown:SetAllPoints(MMBevocationFrame)
 		CreateFrame("Cooldown","MMBevocationgradCooldown",MMBevocationgradFrame)
		MMBevocationgradCooldown:SetAllPoints(MMBevocationgradFrame)
        CreateFrame("Cooldown","MMBmanaGemCooldown",MMBmanaGemFrame)
		MMBmanaGemCooldown:SetAllPoints(MMBmanaGemFrame)
        CreateFrame("Cooldown","MMBmanaGemgradCooldown",MMBmanaGemgradFrame)
		MMBmanaGemgradCooldown:SetAllPoints(MMBmanaGemgradFrame)
        CreateFrame("Cooldown","MMBmageArmorgradCooldown",MMBmageArmorgradFrame)
		MMBmageArmorgradCooldown:SetAllPoints(MMBmageArmorgradFrame)
        CreateFrame("Cooldown","MMBmageArmorCooldown",MMBmageArmorFrame)
		MMBmageArmorCooldown:SetAllPoints(MMBmageArmorFrame)
	    CreateFrame("Cooldown","MMBArcaneTorrentCooldown",MMBArcaneTorrentFrame)
		MMBArcaneTorrentCooldown:SetAllPoints(MMBArcaneTorrentFrame)
	    CreateFrame("Cooldown","MMBArcaneTorrentgradCooldown",MMBArcaneTorrentgradFrame)
		MMBArcaneTorrentgradCooldown:SetAllPoints(MMBArcaneTorrentgradFrame)

        if (select(2, UnitRace("player")) == "Blood Elf") then
            MMBbloodelfracial = true
        else MMBbloodelfracial = false
            MMBArcaneTorrent:Hide()
        end 
        
    end
    
    if (event == "UNIT_MAXPOWER") then
    	
    	local unit, powertype = select(1, ...)
    	
    	if (unit == "player") then
    	
    		MMBManabarMaxPool()
    		
    	end
    end
    
    if (event=="COMBAT_LOG_EVENT_UNFILTERED") then

    	local timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical = select(1, ...)
            
            if (sourceName == UnitName("player")) then
            	
            	if (event == "SPELL_PERIODIC_ENERGIZE") and (spellId == 6117) then -- mage armor cooldown
            		MMBmageArmorgradCooldown:SetCooldown(0,0)
            		MMBmageArmorCooldown:SetCooldown(GetTime(),5)
       			end
            end
	end
    
end


	
-------------------------------------------------------------------------------------------------------	
-------------------------------------------------------------------------------------------------------	
-------------------------------- ON_UPDATE FUNCTION ----------------------------------------------------

function MageManaBar_OnUpdate(self, elapsed)
    self.TimeSinceLastUpdate = (self.TimeSinceLastUpdate or 0) + elapsed;
    self.TimeSinceLastUpdate1sec = (self.TimeSinceLastUpdate1sec or 0) + elapsed;
    
		if (self.TimeSinceLastUpdate > MageManaBar_UpdateInterval) then
            
            MMBManabarUpdate()
            MMBmanaInfoUpdate()
            MMBwarning()
            
            MMBSpellTimer("manaGem",5405)
            MMBSpellTimer("evocation",12051)
            MMBSpellTimer("ArcaneTorrent",28730)
            
            ------------------------------------- Arcane Torrent stuff
            
            MMBArcaneTorrent:ClearAllPoints()
		    MMBArcaneTorrent:SetPoint("TOPLEFT",MageManaBarFrame,"TOPRIGHT", 0-(MageManaBarOverflowFrame:GetWidth()*0.06),0)
            
            ------------------------------------- Mage Armor stuff
            
            MMBmageArmor:ClearAllPoints()
		    MMBmageArmor:SetPoint("TOPLEFT",MageManaBarFrame,"TOPLEFT", (MageManaBarOverflowFrame:GetWidth()*0.03) + (MageManaBarOverflowFrame:GetWidth()*(UnitPower("player")/UnitPowerMax("player"))),0)
            
            self.TimeSinceLastUpdate = 0
            
        end

		if (self.TimeSinceLastUpdate1sec > MageManaBar1sec_UpdateInterval) then
            
   			MMBTimeTo()

            self.TimeSinceLastUpdate1sec = 0
            
        end
end
